# Esercizio Project management
#  DATI
set Activities;
param d {Activities};		#  Durate [min]
set Precedences within Activities cross Activities;

# VARIABILI
var s {Activities} >=0;			# Inizio attivit [min]
var e {Activities};				# Fine attivit [min]
var Makespan;					# Durata totale [min]

# VINCOLI
# Vincoli di precedenza [min]
subject to Precedenze {(i,j) in Precedences}:
  s[j] >= e[i];

# Vincolo sulla durata di ogni attivit [min]
subject to InizioFine {i in Activities}:
  e[i] - s[i] >= d[i];

# Linearizzazione f.o. min-max [min]
subject to DurataTotale {i in Activities}:
  Makespan >= e[i];

# OBIETTIVO
# Minimizzare la durata totale del progetto [min]
minimize z: Makespan;

###################
data;
set Activities := A B C D E F G H;

param d :=
A	25
B	30
C	15
D	22
E	13
F	34
G	15
H	14;

set Precedences :=
A D
B E
B F
C F
D G
D H
E G
E H;

end;
