# Esercizio Project management
#  DATI
set Activities;
set Precedences within Activities cross Activities;
param dA {Activities};		# Durata con 100% di A
param dB {Activities};		# Durata con 100% di B

# VARIABILI
var s {Activities} >=0;			# Inizio attivit [min]
var e {Activities};				# Fine attivit [min]
var Makespan;					# Durata totale [min]
var eta >=0, <=1;				# Frazione di A nella miscela

# VINCOLI
# Vincoli di precedenza [min]
subject to Precedenze {(i,j) in Precedences}:
  s[j] >= e[i];

# Vincolo sulla durata di ogni attivit [min]
subject to InizioFine {i in Activities}:
  e[i] - s[i] >= eta * dA[i] + (1 - eta) * dB[i];

# Linearizzazione f.o. min-max [min]
subject to DurataTotale {i in Activities}:
  Makespan >= e[i];

# OBIETTIVO
# Minimizzare la durata totale del progetto [min]
minimize z: Makespan;

###################
data;
set Activities := A B C D E F G H;

set Precedences :=
A D
B E
B F
C F
D G
D H
E G
E H;

param:	dA		dB :=
A		30		20
B		15		45
C		25		 5
D		32		12
E		14		12
F		19		49
G		20		10
H		10		18;

end;
